/* Problem URL: https://codeforces.com/problemset/problem/2126/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;

        vi fds(n);
        cin >> fds;

        V<unordered_map<int, ll>> cl(n);
        V<V<pair<int, ll>>> graph(n);
        vi par(n);
        vl cost(n);

        rep(i, n - 1) {
            int a, b;
            ll c;
            cin >> a >> b >> c;
            a--, b--;

            graph[a].emplace_back(b, c);
            graph[b].emplace_back(a, c);
        }

        ll ans = 0;

        function<void(int, int)> dfs = [&](int i, int p) {
            for (auto [j, c] : graph[i]) {
                if (j == p) {
                    continue;
                }

                if (fds[j] != fds[i]) {
                    ans += c;
                }

                cl[i][fds[j]] += c;
                par[j] = i;
                cost[j] = c;

                dfs(j, i);
            }
        };

        dfs(0, 0);

        while (q--) {
            int a, c;
            cin >> a >> c;
            a--;

            ans += cl[a][fds[a]];
            ans -= cl[a][c];

            if (a != 0) {
                cl[par[a]][fds[a]] -= cost[a];
                cl[par[a]][c] += cost[a];

                if (c != fds[par[a]] && fds[a] == fds[par[a]]) {
                    ans += cost[a];
                } else if (c == fds[par[a]] && fds[a] != fds[par[a]]) {
                    ans -= cost[a];
                }
            }

            fds[a] = c;

            cout << ans << '\n';
        }
    }
}
